var win = Titanium.UI.currentWindow;

function getTable(deletes){
  // create table view data object
  var data = [];
  var x = 0;
  var rowCounter = 0;

  var db = Titanium.Database.open('airqualitydb');
  var rows = db.execute('SELECT * FROM AIRQUALITY');
  var locationCount = rows.getRowCount();

  // Build the table from the database
  while (rows.isValidRow()) {
    rowCounter++;
  	var title = rows.fieldByName('name');
  	var url = 'http://feeds.enviroflash.info/rss/realtime/' + rows.fieldByName('id') + '.xml';
  	var row = Ti.UI.createTableViewRow({
  	  height:40,
  	  className:'datarow',
  	  clickName:'row'
  	});
  	var label = Ti.UI.createLabel({
  		text:title,
  		left:5,
  		top:5,
  		bottom:5,
  		width:200,
  		color:'#000',
  		url:url,
  		clickName:'city',
  	});
  	row.add(label);

  	row.url = 'http://feeds.enviroflash.info/rss/realtime/' + rows.fieldByName('id') + '.xml';

  	data[x++] = row;
  	// Make sure to set the url but not in the table rows.
  	rows.next();
  }
  rows.close();
  db.close(); // close db when you're done to save resources
  return({data:data});
}

var tableview = Titanium.UI.createTableView(getTable());
Titanium.UI.currentWindow.add(tableview);

// Display the sucker when clicked, only then do a pull from the web
tableview.addEventListener('click',function(e)
{
  if (e.source.clickName == 'remove')
  {
  }
  else
  {
    var actInd = Titanium.UI.createActivityIndicator({
    	bottom:10, 
    	height:50,
    	width:10,
    	style:Titanium.UI.iPhone.ActivityIndicatorStyle.PLAIN
    });
    actInd.style = Titanium.UI.iPhone.ActivityIndicatorStyle.PLAIN;
    actInd.font = {fontFamily:'Helvetica Neue', fontSize:15,fontWeight:'bold'};
  	actInd.color = 'white';
  	actInd.message = 'Loading...';
  	actInd.width = 210;
  	actInd.show();
    var xhr = Ti.Network.createHTTPClient();
    xhr.open("GET",e.row.url);
    xhr.onload = function()
    {
  		var doc = this.responseXML.documentElement;
  		var items = doc.getElementsByTagName("item");
  		var doctitle = doc.evaluate("//channel/title/text()").item(0).nodeValue;
  		for (var c=0;c<items.length;c++)
  		{
  			var item = items.item(c);
  			var description = item.getElementsByTagName("description").item(0).text;        
  		}
  		var w = Ti.UI.createWindow({title:doctitle});
    	var wb = Ti.UI.createWebView({html:description});
    	w.add(wb);
    	actInd.hide();
    
    	var b = Titanium.UI.createButton({
    		title:'Close',
    		style:Titanium.UI.iPhone.SystemButtonStyle.PLAIN,
    		bottom:0,
    		left:0,
    	});
    	w.setLeftNavButton(b);
    	w.add(b);
    	b.addEventListener('click',function()
    	{
    		w.close();
    	});
    	w.open({modal:true});
    }
  xhr.send();  
  }
});
