// **************  VARIABLES  **************
var data = [];
var x = 0;
var states = ["AL","AK","AZ","AR","CA","CO","CT","DE","DC","FL","GA","HI","ID","IL","IN","IA","KS","KY","LA","ME","MD","MA","MI","MN","MS","MO","MT","NE","NV","NH","NJ","NM","NY","NC","ND","OH","OK","OR","PA","RI","SC","SD","TN","TX","UT","VT","VA","WA","WV","WI","WY"];
var uiTop = 30;
var uiLabelTop = 75;
var tableBottom = 50;
dbName = "airqualitydatabase";

// **************  DATABASE  **************  
var db = Titanium.Database.open(dbName);

var rowCounter = 0;
db.execute('CREATE TABLE IF NOT EXISTS AIRQUALITY  (ID INTEGER, URL TEXT, NAME TEXT, O INT, P INT)');
var rows = db.execute('SELECT * FROM AIRQUALITY');
var locationCount = rows.getRowCount();


// **************  UI  **************
// Window
var win = Titanium.UI.currentWindow;
var labelBackLabel = Ti.UI.createLabel({
  left:0,
  top:uiTop,
  width:Titanium.Platform.displayCaps.platformWidth,
	height: 40,
	backgroundColor: '#e2e2e2',
})
var infoLabel = Ti.UI.createLabel({
	left:5,
	right:5,
	top:uiTop+5,
  height: 35,
	width:Titanium.Platform.displayCaps.platformWidth,
	color:'#000',
});
win.backgroundImage = 'background.png';
win.add(labelBackLabel);
win.add(infoLabel)

var refreshButton = Ti.UI.createButton({
  bottom:5,
  left:10,
  right:10,
  width:Titanium.Platform.displayCaps.platformWidth,
  height: 40,
  border:{borderRadius:3,borderColor:'#0d3f66',borderWidth:1},
	font:{fontFamily:'Trebuchet MS',fontSize:16,fontWeight:'bold'},
  title:"Refresh Cities",
  backgroundColor: '#7bbae7',
})
win.add(refreshButton);

var headerLabel = Ti.UI.createLabel({
  top:0,
  left:0,
  height:30,
  width:Titanium.Platform.displayCaps.platformWidth,
  backgroundColor: '#7bbae7',
  color: '#000',
  font:{fontFamily:'Trebuchet MS',fontSize:14,fontWeight:'bold'},
  text:"  City",
  borderWidth: 1,
});
win.add(headerLabel);
var headerLabelc = Ti.UI.createLabel({
  top:0,
  left:38,
  height:30,
  width:Titanium.Platform.displayCaps.platformWidth,
  backgroundColor: '#7bbae7',
  color: '#666',
  font:{fontFamily:'Trebuchet MS',fontSize:12},
  text:"(click any city for forecast)",
  borderWidth: 1,
});
win.add(headerLabelc);
var headerLabelO = Ti.UI.createLabel({
  top:0,
  right:87,
  height:30,
  color: '#000',
  text:"Oz",
  font:{fontFamily:'Trebuchet MS',fontSize:14,fontWeight:'bold'},
});
win.add(headerLabelO);
var headerLabelP = Ti.UI.createLabel({
  top:0,
  right:53,
  height:30,
  color: '#000',
  text:"Prt",
  font:{fontFamily:'Trebuchet MS',fontSize:14,fontWeight:'bold'},
});
win.add(headerLabelP);
var headerLabelD = Ti.UI.createLabel({
  top:0,
  right:12,
  height:30,
  color: '#000',
  text:"Del",
  font:{fontFamily:'Trebuchet MS',fontSize:14,fontWeight:'bold'},
});
win.add(headerLabelD);
// Table
var tableview = Ti.UI.createTableView({
	style:Titanium.UI.iPhone.TableViewStyle.GROUPED,
	bottom:50,
	width:Titanium.Platform.displayCaps.platformWidth,
  height:Titanium.Platform.displayCaps.platformHeight - 70,
  
});

tableview.top = uiLabelTop;
win.add(tableview);

tableview.setData([]);
setTimeout(function()
{
	setData();
},1000);



// Options Menu
menu = Titanium.UI.Android.OptionMenu.createMenu();
var city = Titanium.UI.Android.OptionMenu.createMenuItem({ 
  title:'Add a new city',
  icon:'ic_menu_add.png',
});
var info = Titanium.UI.Android.OptionMenu.createMenuItem({ 
  title: 'More information',
  icon:'ic_menu_info_details.png',
});
menu.add(city);
menu.add(info);
Titanium.UI.Android.OptionMenu.setMenu(menu);

var clearAlertDialog = Titanium.UI.createAlertDialog({
    title: 'Remove City?',
    message: 'Remove City?',
    buttonNames: ['Yes!','Oh Noes!'],
    cancel:0,
});

if (locationCount == 0) {
  var noRows = "TRUE";
  labelBackLabel.show();
  infoLabel.show();
  tableview.top = uiLabelTop;
  infoLabel.text = "No cities, press menu to add some.";
}
else {
  var noRows = "FALSE";
  tableview.top = uiTop;
  labelBackLabel.hide();
  infoLabel.hide();
}

var actInd = Titanium.UI.createActivityIndicator({
	bottom:10, 
	height:50,
	width:10,
	style:Titanium.UI.iPhone.ActivityIndicatorStyle.PLAIN
});
actInd.style = Titanium.UI.iPhone.ActivityIndicatorStyle.PLAIN;
actInd.font = {fontFamily:'Helvetica Neue', fontSize:15,fontWeight:'bold'};
actInd.color = 'white';
actInd.message = 'Loading...';
actInd.width = 210;

if (rows.getRowCount() > 0) {
  actInd.show();
  // Build the table from the database
  while (rows.isValidRow()) {
  	getDescription(rows.fieldByName('id'));
  	setTimeout(function()
    {
    	Ti.API.info("So refreshing.");
    },1000);
    rows.next();
  }
  rows.close();
  actInd.hide();
}

// **************  EVENTS  **************  
tableview.addEventListener('doubleclick', function(re) {
  var cityName = re.source.city;
  removeCity(cityName);
});

// Listener for refreshing the table
refreshButton.addEventListener('click', function(){
  tableview.setData([]);
  setTimeout(function()
  {
  	setData();
  },1000);
});

// Display the sucker when clicked, only then do a pull from the web
tableview.addEventListener('click',function(te)
{
  if (te.source.clickName == 'remove') 
  {
    clearAlertDialog.show();
    // The dialog for clearing all cities, this does the work
    clearAlertDialog.addEventListener('click', function(ke){
      if (ke.index == 0.0) {
        removeCity(te.source.name);
        tableview.setData([]);
        setData();
      }
    });
    
  }
  else
  {
    getForecast(te.row.nid);
  }
});

info.addEventListener('click',function(){
  var infoWin = Ti.UI.createWindow();
  desc = "<h3>Air Alert Info</h3>";
  desc += "<p style='font-size: 12px;'>Here is a little more info about this app.  Use this app ";
  desc += "to view current Ozone (Oz) and Particulate (Prt) Air Quality Index levels as reported by AirNow.gov.";
  desc += "  You will see air quality conditions for cities you choose, with colors giving an at-a-glance ";
  desc += "view of the conditions, going from green (good), to red (not good).</p>";
  desc += "<p style='font-size: 12px;'>Click any city to see forecast data for that city.  Some cities have no data.</p>"
  desc += "<p style='font-size: 12px;'>If you aren't seeing the numbers or are having any other problem with the data, ";
  desc += "try clicking the refresh button or check your connection to the net.</p>";
  desc += "<p style='font-size: 12px;'>This app was produced by Patrick Teglia (Copyright 2010-2011). You may find updates ";
  desc += 'or news about the app on his website: <a href="http://patrickteglia.com">http://patrickteglia.com</a></p>';
	
	var ib = Titanium.UI.createButton({
		title:'Close',
		style:Titanium.UI.iPhone.SystemButtonStyle.PLAIN,
		bottom:0,
		right:0,
		height: 30,
	});
	infoWin.setLeftNavButton(ib);
	var wb = Ti.UI.createWebView({html:desc});
	wb.backgroundColor = "#e2e2e2";
	infoWin.add(wb);
	infoWin.bottom = 35;
	infoWin.add(ib);
	
	ib.addEventListener('click',function()
	{
		infoWin.close();
	});
	infoWin.open({modal:true});
});

city.addEventListener('click',function(e){
  var dialog = Titanium.UI.createOptionDialog({
      title: 'Select a State',
      options: states,
      cancel:1,
      clickName:'states'
  });
  // Wait for the state dialog to be clicked
  dialog.addEventListener('click',function(e){
    var xhr = Titanium.Network.createHTTPClient(); 
    var citiesIndex = [];
  	var state = states[e.index];
  	actInd.show();
    xhr.onload = function(){ 
      var cities = [];
  		var doc = this.responseXML.documentElement;
      var citylist = doc.getElementsByTagName('city');
      for (var c=0;c<citylist.length;c++){
    		var item = citylist.item(c);
    		var number = item.getElementsByTagName("number").item(0).text;
    		var cityName = item.getElementsByTagName("name").item(0).text;
    		citiesIndex[c] = number;
    		cities[c] = cityName;
    	}
    	
      // Can't build the city dialog until we have the cities from the state above.
      var cityDialog = Titanium.UI.createOptionDialog({
        title: 'Select a City',
        options: cities,
        cancel:1,
        clickName:'cities'
      });
      actInd.hide();
      cityDialog.show();
      
      // Likewise, the city event listener doesn't make sense without the city dialog.
      cityDialog.addEventListener('click',function(ge)
      { 
        addCity(cities[ge.index],citiesIndex[ge.index]);
        tableview.setData([]);
      	setTimeout(function()
      	{
      		setData();
      	},1000);
        noRows = "FALSE";       
        win.title = "Air Quality - Current Conditions";      
      });
    }
    xhr.onerror = function()
    {
      Ti.API.info('Something went wrong.');
    }
    // Don't change this URL unless you replicate the state's city lists on your own server
    // from airnow.gov's data.
    xhr.open("GET","http://patrickteglia.com/citylist/" + state + ".xml");  
  	xhr.send();
  });
  dialog.show();
});

// **************  FUNCTIONS  **************  

function getForecast(nid,forecast) {
  var url = "http://feeds.enviroflash.info/rss/forecast/" + nid + ".xml"
  actInd.show();
  var xhr = Ti.Network.createHTTPClient();
  xhr.open("GET",url);
  xhr.onload = function()
  {
		var doc = this.responseXML.documentElement;
		var items = doc.getElementsByTagName("item");
		var doctitle = doc.evaluate("//channel/title/text()").item(0).nodeValue;
		for (var c=0;c<items.length;c++)
		{
			var item = items.item(c);
			var description = item.getElementsByTagName("description").item(0).text;        
		}
		var w = Ti.UI.createWindow();
  	var wb = Ti.UI.createWebView({html:description});
  	w.add(wb);
  	actInd.hide();

  	var b = Titanium.UI.createButton({
  		title:'Close',
  		style:Titanium.UI.iPhone.SystemButtonStyle.PLAIN,
  		bottom:0,
  		left:0,
  	});
  	w.setLeftNavButton(b);
  	w.add(b);
  	b.addEventListener('click',function()
  	{
  	  win.title = "Air Quality - Current Conditions";
  		w.title = "Air Quality - Current Conditions";
  		w.close();
  	});
  	w.open({modal:true});
  }
  xhr.send();
}

function getDescription(nid) {
  var description = '';
  var url = 'http://feeds.enviroflash.info/rss/realtime/' + nid + '.xml';
  var descxhr = Ti.Network.createHTTPClient();
  descxhr.open("GET",url);
  descxhr.onload = function()
  {
		var doc = this.responseXML.documentElement;
		var items = doc.getElementsByTagName("item");
		var doctitle = doc.evaluate("//channel/title/text()").item(0).nodeValue;
		for (var c=0;c<items.length;c++)
		{
			var item = items.item(c);
			var description = item.getElementsByTagName("description").item(0).text;  
			var ozone = getOzone(description);
    	var particle = getParticle(description);
  	
      if (ozone > 0) {
        db.execute('UPDATE AIRQUALITY SET O = ? WHERE ID = ?', ozone, nid);
      }
      
      if (particle > 0) {
        db.execute('UPDATE AIRQUALITY SET P = ? WHERE ID = ?', particle, nid);
      }
		}     
    
    
  }
  descxhr.send();
}




/**
 * getTable() 
 * returns: data list ready for table insertion.
 */
function getTable(){
  // create table view data object
  var data = [];
  var x = 0;
  var db = Titanium.Database.open(dbName);
  var rows = db.execute('SELECT * FROM AIRQUALITY');
  if (rows.getRowCount() > 0) {
    // Build the table from the database
    while (rows.isValidRow()) {   
      var description = '';
    	var title = rows.fieldByName('name');
    	var nid = rows.fieldByName('id');
    	getDescription(nid);   
      
    	var ozone = rows.fieldByName('o');
    	var particle = rows.fieldByName('p');
    	var url = 'http://feeds.enviroflash.info/rss/forecast/' + rows.fieldByName('id') + '.xml';
    	var row = Ti.UI.createTableViewRow({
    	  height:50,
    	  className:'datarow',
    	  clickName:'row'
    	});
    	var label = Ti.UI.createLabel({
    		text:title,
    		left:5,
    		top:5,
    		bottom:5,
    		width:200,
    		color:'#0d3f66',
				font:{fontFamily:'Trebuchet MS',fontSize:14,fontWeight:'bold'},
    		url:url,
    		clickName:'city',
    	});
    	
      if (ozone > 0) {
        var ozoneLabel = Ti.UI.createLabel({
          text:ozone,
          right:68,
          top:5,
          bottom:5,
          width:30,
          height:30,
          font:{fontFamily:'Trebuchet MS',fontSize:14,fontWeight:'bold'},
          color:'#fff',
          textAlign:'center',
          backgroundImage:getBgColor(ozone),
          clickName:'city',
        });
        row.add(ozoneLabel);
      }
    
      if (particle > 0) {
        var particleLabel = Ti.UI.createLabel({
          text:particle,
          right:36,
          top:5,
          bottom:5,
          width:30,
          height:30,
          color:'#fff',
          font:{fontFamily:'Trebuchet MS',fontSize:14,fontWeight:'bold'},
          textAlign:'center',
          backgroundImage:getBgColor(particle),
          clickName:'city',
        });
        row.add(particleLabel);
      }
  		
  		var removeButton = Ti.UI.createLabel({
        right:0,
        top:5,
        bottom:5,
        width:32,
        height:32,
        backgroundImage:'ic_menu_delete.png',
        clickName: 'remove',
        name: title,	  
  		});
  		
    	row.city = title;
    	row.nid = rows.fieldByName('id');
    	row.add(label);
    	row.add(removeButton);
    	data[x++] = row;
    	// Make sure to set the url but not in the table rows.
    	rows.next();
    }
    rows.close();
    var noRows = "FALSE";
    tableview.top = uiTop;
    labelBackLabel.hide();
    infoLabel.hide();

  }
  else {
  	var row = Ti.UI.createTableViewRow({
  	  height:0,
  	  className:'datarow',
  	  clickName:'row'
  	});
  	data[x++] = row;
    var noRows = "TRUE";
    labelBackLabel.show();
    infoLabel.show();
    tableview.top = uiLabelTop;
    infoLabel.text = "No cities, press menu to add some.";
  }
  db.close(); // close db when you're done to save resource
  return(data);
}

function getBgColor(level) {
  if (level <= 50){ return("green-box.png");}
  if (level <= 100){ return("yellow-box.png");}
  if (level <= 150){ return("orange-box.png");}
  if (level <= 200){ return("red-box.png");}
  if (level <= 300){ return("wine-box.png");}
  if (level <= 500){ return("dark-box.png");}
}

function getOzone(description) {
	var ozone = 0;
	var ozoneYes = description.search("Ozone");   
	if (ozoneYes > 0) {
	  var ozoneData = description.substr(ozoneYes-9, 3);
	  ozone = parseInt(ozoneData);
	}
	return(ozone);
}

function getParticle(description) {
	var particle = 0;
  var particleYes = description.search("Particle");   
	if (particleYes > 0) {
	  var particleData = description.substr(particleYes-9, 3);
	  particle = parseInt(particleData);
	}  
	return(particle);
}

function removeCity(cityName){
  var db = Titanium.Database.open(dbName);
  db.execute('DELETE FROM AIRQUALITY WHERE NAME = ?', cityName);
  db.close();
}

function addCity(cityName,cityNumber){
  var db = Titanium.Database.open(dbName);
  db.execute('INSERT INTO AIRQUALITY (ID, URL, NAME ) VALUES(?,?,?)',cityNumber,"http://feeds.enviroflash.info/rss/forecast/" + cityNumber + ".xml", cityName);
  db.close();
}

function removeAll(){
  var db = Titanium.Database.open(dbName);
  db.execute('DELETE FROM AIRQUALITY');
  db.close();
  tableview.setData([]);
  var noRows = "TRUE";
  labelBackLabel.show();
  infoLabel.show();
  tableview.top = uiLabelTop;
  infoLabel.text = "No cities, press menu to add some.";
  win.title = "Air Quality - Current Conditions";
}

function setData(){
  var data = [];
  data = getTable();
  tableview.setData(data);
  win.title = "Air Quality - Current Conditions";
}