var win = Titanium.UI.currentWindow;
win.backgroundColor = '#fff';
var data = [];
var x = 0;

var db = Titanium.Database.open('airqualitydb');
var rows = db.execute('SELECT * FROM AIRQUALITY');

// Build the table from the database
while (rows.isValidRow()) {
	var title = rows.fieldByName('name');
	var row = Ti.UI.createTableViewRow({
	  height:40,
	  className:'datarow',
	  clickName:'row'
	});
	var label = Ti.UI.createLabel({
		text:title,
		left:5,
		top:5,
		bottom:5,
		width:200,
		color:'#000',
		clickName:'remove',
		city:title,
	});

	row.add(label);

	var button = Ti.UI.createView({
	  backgroundImage:'minusDefault.png',
		top:2,
		right:5,
		width:36,
		height:36,
		city:title,
		clickName:'remove',
	});

	row.add(button);	
	data[x++] = row;
	rows.next();
}
rows.close();

var tableview = Titanium.UI.createTableView({data:data});
win.add(tableview);
menu = Titanium.UI.Android.OptionMenu.createMenu();
var city = Titanium.UI.Android.OptionMenu.createMenuItem({ title:'Add a new city' });
menu.add(city);
Titanium.UI.Android.OptionMenu.setMenu(menu);


// Display the sucker when clicked, only then do a pull from the web
tableview.addEventListener('click',function(e)
{
  if (e.source.clickName == 'remove')
  {
    var cityName = e.source.city;
    db.execute('DELETE FROM AIRQUALITY WHERE NAME = ?', cityName);
    tableview.deleteRow(e.index);
  }
});

city.addEventListener('click',function(e)
{
  // Wait for the state dialog to be clicked
  dialog.addEventListener('click',function(e)
  {
    var xhr = Titanium.Network.createHTTPClient(); 
    var city = "";
    var cities = [];
    var citiesIndex = [];
  	var state = states[e.index];
    xhr.onload = function()
    { 
      cities = [];
  		var doc = this.responseXML.documentElement;
      var citylist = doc.getElementsByTagName('city');
      for (var c=0;c<citylist.length;c++)
    	{
    		var item = citylist.item(c);
    		var number = item.getElementsByTagName("number").item(0).text;
    		var cityName = item.getElementsByTagName("name").item(0).text;
    		citiesIndex[c] = number;
    		cities[c] = cityName;
    	}

      var cityDialog = Titanium.UI.createOptionDialog({
        title: 'Select a City',
        options: cities,
        cancel:1,
        clickName:'cities'
      });

      cityDialog.show();
    
      cityDialog.addEventListener('click',function(ge)
      {
        var cityName = cities[ge.index];
        var cityNumber = citiesIndex[ge.index];
        alert("Saved " + cities[ge.index] + ".");
        db.execute('INSERT INTO AIRQUALITY (ID, URL, NAME ) VALUES(?,?,?)',citiesIndex[ge.index],"http://feeds.enviroflash.info/rss/forecast/" + cityNumber + ".xml", cityName);
        var row = Ti.UI.createTableViewRow({
      	  height:40,
      	  className:'datarow',
      	  clickName:'row'
      	});
      	var label = Ti.UI.createLabel({
      		text:cityName,
      		left:5,
      		top:5,
      		bottom:5,
      		width:200,
      		color:'#000',
      		clickName:'remove',
      		city:cityName,
      	});

      	row.add(label);

      	var button = Ti.UI.createView({
      	  backgroundImage:'minusDefault.png',
      		top:2,
      		right:5,
      		width:36,
      		height:36,
      		city:cityName,
      		clickName:'remove',
      	});
      	row.add(button);	
    	
        tableview.appendRow(row)
      
      });
    }
    xhr.onerror = function()
    {
      Ti.API.info('Something went wrong.');
    }
    xhr.open("GET","http://patrickteglia.com/citylist/" + state + ".xml");  
  	xhr.send();
  });


  dialog.show();
});

var states = ["AL","AK","AZ","AR","CA","CO","CT","DE","DC","FL","GA","HI","ID","IL","IN","IA","KS","KY","LA","ME","MD","MA","MI","MN","MS","MO","MT","NE","NV","NH","NJ","NM","NY","NC","ND","OH","OK","OR","PA","RI","SC","SD","TN","TX","UT","VT","VA","WA","WV","WI","WY"];
var dialog = Titanium.UI.createOptionDialog({
    title: 'Select a State',
    options: states,
    cancel:1,
    clickName:'states'
});